# OceanFlux Greenhouse Gases default climatology configuration file
# created 27/07/2016 Jamie Shutler, j.d.shutler@exeter.ac.uk
# last updated 21/05/2019 Tom Holding, t.m.holding@exeter.ac.uk
# 
# This file contains the run configuration options for FluxEngine, including:
# Input datasets, filepaths and identifiers, gas transfer velocity parameterisation, flux calculation selection and other options
# All settings are defined following the "option_name = option_value" format. Comments are prefixed using '#'


# Flux calculation options. Valid options are 'bulk', 'rapid' or 'equilibrium'
# 'rapid' and 'equilibrium' are in relation to the flux model as described in
# Woolf et al., 2012.
flux_calc = rapid

# If sst_gradients enables and only one of sstskin or sstfnd is used the other
# will be derived according to, i.e.:
# 		sstskin = sstfnd - cool_skin_difference
# Default value for cool_skin_difference is 0.17K (Donlon et al., 2002)
# At least one must be selected.
sst_gradients = yes
cool_skin_difference = 0.17
saline_skin_value = 0.1

# Latitude, longitude and time product names (these are taken from the data layer names in
# axes_data_layer, which must contain the name of datalayer defined below, e.g. 'sstskin').
# Typically 'lat' and 'lon' unless using Takahashi which is 'latitude' and 'longitude'.
axes_data_layer = sstskin
latitude_prod = lat
longitude_prod = lon
time_prod = time


# Selected gas transfer velocity (k) parameterisation. Options include:
# k_Ho2006, k_Nightingale2000, kt_OceanFluxGHG, k_Wanninkhof1992, k_Wanninkhof2014, 
# k_McGillis2001, k_Ho1997, kd_OceanFluxGHG_backscatter, kd_OceanFluxGHG_wind, 
# kb_OceanFluxGHG, kt_OceanFluxGHG_kd_wind, k_generic
k_parameterisation = k_Wanninkhof2014
schmidt_parameterisation = schmidt_Wanninkhof2014


#
# Output directory for the resultant netcdf files
#
output_dir = tutorial_output
output_structure = #intentially blank



##############################################################
# Input data layers and their associated data variable names #
##############################################################
# Required input data layers are:
# 		* windu10
#		* sstskin and/or sstfnd
#		* pco2_sw
#		* vco2_air or pco2_air
#
# Additionally ice coveraged is required if using the ghgflux-budgets tool to calculate integrated net flux. 
#
# Issues to note:
#  - All entries are case sensitive
#  - Additional options can be set and will be automatically available in FluxEngine (e.g. for use with custom gas transfer velocity parameterisations)
#
# Filepaths can contain the following tokens to allow different data to be selected for different time steps:
#    <YYYY>  - converted to 4 digit year, e.g. 1999
#    <YY>    - converted to 2 digit year, e.g.   99
#    <MM>	 - converted to two digit month, e.g. 01 for January
#	 <Mmm>	 - converted to three letter month abbreviation, e.g. Jan for January
#    <MMM>	 - uppercase three letter month abbreviation, e.g. JAN
#    <mmm>	 - lowercase three letter month abbreviation, e.g. jan
#	 <DD>	 - two digit decimal representation of the day of the month, e.g. 01 for the 1st day of the month
#	 <DDD>	 - three digit decimal representation of the day of the year, e.g. 123 for 3rd May (124 on a leap year)
#
# In addition to these tokens, filename patterns can be specified using ? and * which
# follow the standard Unix glob behaviour.
#

# Each input data layer requires at least a file path (to the .nc file, set using datalayername_path) and a 'product'
# name (to the variable within the .nc file, set using datalayername_prod) is the name of the data set within the netCDF file. This can be checked using 'ncdump -h <file.nc> | less'
# 'analysed_sst_mean'

# To specify an input data layer you must define a minimum of its filepath (using datalayername_path) and its 'product' name (datalayername_prod).
#The product name is the variable name within the netCDF (.nc) file. E.g.:
# sstskin_path = path/to/data.nc
# sstskin_prod = sst_skin_mean
# 
# Other suffixes can be used.
#   _path		    - Filepath to the netCDF (.nc) file containing this data.
#				      May be relative or absolute and can contain the tokens described above.
#	_prod           - The name of the variable within the netCDF file.
#	_stddev_prod    - Optional. Name of the variable containing standard deviation data.
#	_count_prod	    - Optional. Name of the variable containing count data.
#   _netCDFName     - Optional. Override the name which will be given to the data layer in the
#					- output netCDF file.
#	_minBound	    - Optional. Override the minimum allowed value.
#	_maxBound	    - Optional. Override the maximum allowed value.
#   _preprocessing	- Optional. A list of functions used to transform the data before it is used.
#					- Functions should be seperated by commas and are applied in order.
#					- Functions must be defined in src_home/data_preprocessing.py
#


# sst skin data inputs
sstskin_path = <FEROOT>/data/verification_data/SST/<YYYY>/<YYYY><MM>01_OCF-SST-GLO-1M-100-ATS-ARC.nc
sstskin_prod = sst_skin_mean


# U10 wind data inputs
windu10_path = <FEROOT>/data/verification_data/globwave/<YYYY>/<YYYY><MM>_OCF-WSP-GLO-1M-100-MGD-GW-v2.nc
windu10_prod = wind_speed_cor_mean

windu10_moment2_path = <FEROOT>/data/verification_data/globwave/<YYYY>/<YYYY><MM>_OCF-WSP-GLO-1M-100-MGD-GW-v2.nc
windu10_moment2_prod = wind_speed_cor_moment_2

windu10_moment3_path = <FEROOT>/data/verification_data/globwave/<YYYY>/<YYYY><MM>_OCF-WSP-GLO-1M-100-MGD-GW-v2.nc
windu10_moment3_prod = wind_speed_cor_moment_3


# sea ice fraction data
ice_path = <FEROOT>/data/verification_data/ice/<YYYY>/2010<MM>01_OCF-ICE-GLO-1M-100-MGD-SSMI.nc
ice_prod = sea_ice_fraction_mean

# modelled air pressure data.
pressure_path = <FEROOT>/data/verification_data/air_pressure/<YYYY>/<YYYY><MM>_OCF-PRE-GLO-1M-100-ECMWF.nc
pressure_prod = msl_mean
pressure_preprocessing = pascal_to_millibar

# sea surface salinity data
salinity_path = copied_data/WOA_salinity/surface_woa18_A5B7_s<MM>_01.nc
salinity_prod = salinity_mean


#atmospheric and ocean CO2 data
vgas_air_path = <FEROOT>/data/verification_data/SOCATv4/<YYYY><MM>01_OCF-CO2-GLO-1M-KRG-CLIM.nc
vgas_air_prod = vCO2
vgas_air_preprocessing = flip_longitude

pgas_sw_path = <FEROOT>/data/verification_data/SOCATv4/<YYYY><MM>01_OCF-CO2-GLO-1M-KRG-CLIM.nc
pgas_sw_prod = pCO2_2010_interpolated_pred
pgas_sw_preprocessing = flip_longitude

pco2_sst_path = <FEROOT>/data/verification_data/SOCATv4/<YYYY><MM>01_OCF-CO2-GLO-1M-KRG-CLIM.nc
pco2_sst_prod = Tcl_2010
pco2_sst_preprocessing = flip_longitude, kelvin_to_celsius
